Create custom Phab form for requesting a new Labs project
Open, NormalPublic

Description

Create a new form for making subtasks of T76375: [DO NOT USE] New Labs project requests (tracking) [superseded by #cloud-vps-project-requests]. Having a custom form should make the instructions more visible:

Before you request a project

Remember that you do not need a labs project to use Tool Labs (which has a lot of capabilities/features). You can request access to toollabs using a form on wikitech. With toollabs, underlying infrastructure will be taken care of for you, and you can focus on writing your tool / bot / researchy-thing. Only request a labs project if you want root on the VM for a specific purpose (or need testing VMs for MediaWiki changes, etc). Remember that if you have root you have responsibilities too! :)

Requesting a new project

To request a new project, create a subtask, with the following information:

Project Name: <projectname>
Purpose: <reason for project request>
Wikitech Username of requestor: <username>

Note that <projectname> should be alphanumeric with dashes - no spaces or special characters other than -.

bd808 created this task.Feb 27 2016, 11:55 PM
Restricted Application added subscribers: StudiesWorld, scfc, Aklapper. · View Herald TranscriptFeb 27 2016, 11:55 PM

In general I don't have a problem with forms like this. But there is a problem:
Each form apears at the create menu which is annoying after a short time, because you don't need to request a project often.
My proposed solution is to ask upstream for a option that allows you to create and use a form (accessible via link), but which doesn't appear at the create menu. What's your opinion?

chasemp triaged this task as Normal priority.Apr 4 2016, 2:12 PM
mmodell added a subscriber: mmodell.Jun 3 2016, 3:58 AM

In general I don't have a problem with forms like this. But there is a problem:
Each form apears at the create menu which is annoying after a short time, because you don't need to request a project often.
My proposed solution is to ask upstream for a option that allows you to create and use a form (accessible via link), but which doesn't appear at the create menu. What's your opinion?

Actually it's possible to have custom forms that don't appear in the menu - just don't mark them as 'create' forms and they don't appear in the global create menu.

Restricted Application added a subscriber: TerraCodes. · View Herald TranscriptJun 3 2016, 3:58 AM

Ok, custom form is created here: https://phabricator.wikimedia.org/maniphest/task/edit/form/20/?parent=76375

We should consider adding a project for labs requests instead of using a tracking task. Especially because the custom form doesn't enforce the parent task id so if someone alters the url to remove the parent= parameter then tasks will be created without the appropriate tracking task dependency.

Krinkle added a subscriber: Krinkle.Jun 3 2016, 9:37 PM

The phrase You can request access to toollabs here is confusing. I guess there was supposed to be a link there? If a link is added, I suggest the text is also changed (e.g. "at x" instead of "here" as label).

bd808 added a comment.Jun 3 2016, 9:48 PM

The phrase You can request access to toollabs here is confusing. I guess there was supposed to be a link there? If a link is added, I suggest the text is also changed (e.g. "at x" instead of "here" as label).

The text was copied from the description of T76375: [DO NOT USE] New Labs project requests (tracking) [superseded by #cloud-vps-project-requests] but apparently not as a copy of the raw markup. I agree the wording could be better. Maybe @mmodell can set the editing ACL on that form so that some of us can help fix the wording?

bd808 added a comment.Jun 3 2016, 9:51 PM

The phrase You can request access to toollabs here is confusing. I guess there was supposed to be a link there? If a link is added, I suggest the text is also changed (e.g. "at x" instead of "here" as label).

The text was copied from the description of T76375: [DO NOT USE] New Labs project requests (tracking) [superseded by #cloud-vps-project-requests] but apparently not as a copy of the raw markup. I agree the wording could be better. Maybe @mmodell can set the editing ACL on that form so that some of us can help fix the wording?

Doh! I now see that I made the shallow copy-n-paste error when I wrote this task in the first place. :/

bd808 updated the task description. (Show Details)Jun 3 2016, 9:52 PM

Ok I've updated the form - I can't adjust the ACL on individual forms, the acl applies globally to creating/editing all custom forms.

I'm comfortable adding a few people to acl*phabricator but it's a powerful privilege - custom forms are somewhat tricky and easy to get wrong. Additionally, our security bug reporting depends on the forms being properly configured.

So use great caution editing forms ;)

Krenair added a subscriber: Krenair.EditedJun 4 2016, 5:53 AM

acl*phabricator doesn't give you the ability to edit the form

Just wondering, why should there be a redirect=no in "capabilities/features" link?

bd808 added a comment.Jun 4 2016, 4:16 PM

acl*phabricator doesn't give you the ability to edit the form

I can confirm that acl*phabricator did not give me the right to edit the form. I voluntarily left the group. I've got enough hats for now. :)

IIRC, administratorship is needed to edit forms all forms. You can't specify edit policy for single forms, and you can't change the edit poliy for all forms yet.